<?php
require_once("../config/session.php");
require_once("../config/function.php");
$main_site_data = main_site_data();
$site_data = site_data();
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <!-- Mobile Specific Metas -->
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, minimum-scale=1, viewport-fit=cover">
    <title> Register | <?=$site_data['brand']?></title>
    <!-- Favicon and Touch Icons  -->
    <link rel="shortcut icon" href="images/logo.png" />
    <link rel="apple-touch-icon-precomposed" href="images/logo.png" />
    <!-- Font -->
    <link rel="stylesheet" href="fonts/fonts.css" />
    <!-- Icons -->
    <link rel="stylesheet" href="fonts/icons-alipay.css">
    <link rel="stylesheet" href="styles/bootstrap.css">

    <link rel="stylesheet" type="text/css" href="styles/styles.css" />
    <link rel="manifest" href="_manifest.json" data-pwa-version="set_in_manifest_and_pwa_js">
    <link rel="apple-touch-icon" sizes="192x192" href="app/icons/icon-192x192.png">
    
</head>

<body>
   <!-- preloade -->
   <div class="preload preload-container">
    <div class="preload-logo">
      <div class="spinner"></div>
    </div>
  </div>
<!-- /preload -->
    <div class="header">
        <div class="tf-container">
            <div class="tf-statusbar br-none d-flex justify-content-center align-items-center">
                <a href="#" class="back-btn"> <i class="icon-left"></i> </a>
            </div>
        </div>
    </div>
    <div class="mt-3 register-section">
        <div class="tf-container">
            <!--form class="tf-form" action="https://themesflat.co/html/alipay/alipay-app-pwa/06_verify-otp.html"-->
            <form class="tf-form" method="POST" action="">
                <?php
if(isset($_POST['createaccount'])){
$name = real_escape_string($_POST['name']);
$company = real_escape_string($_POST['company']);
$mobile = is_valid_mobile($_POST['mobile']);
$email = is_valid_email($_POST['email']);
$aadhaar = is_valid_aadhaar($_POST['aadhaar']);
$pan = is_valid_pan($_POST['pan']);
$address = real_escape_string($_POST['address']);
$pin = is_valid_pincode($_POST['pin']);
$state = is_valid_statecode($_POST['state']);
$usertype = is_valid_usertype($_POST['usertype']);

if(!empty($name) 
&& !empty($company) 
&& !empty($mobile) 
&& !empty($email) 
&& !empty($aadhaar) 
&& !empty($pan) 
&& !empty($address) 
&& !empty($pin) 
&& !empty($state)
&& !empty($usertype)
){

if(in_array($usertype, ['Master Distributor','Distributor','Retailer'])){

$username = get_username($mobile);
$condition = " username='".$username."' || mobile='".$mobile."' ";
$old_member = db_fetch_all("members",$condition);
if(count($old_member)==0){


if($usertype=="Retailer"){
$plan_id = $site_data['retailer_slab'];
}else if($usertype=="Distributor"){
$plan_id = $site_data['distributor_slab'];
}else if($usertype=="Master Distributor"){
$plan_id = $site_data['master_slab'];
}else{
$plan_id = 1;  
}

$password = generateNumericOTP(6);
$insData = array();
$insData['site_id'] = $site_data['site_id'];
$insData['username'] = $username;
$insData['password'] = $password;
$insData['is_otp'] = "NO";
$insData['usertype'] = $usertype;
$insData['parent_id'] = $site_data['user_id'];
$insData['parent_uid'] = $site_data['username'];
$insData['name'] = $name;
$insData['company'] = $company;
$insData['mobile'] = $mobile;
$insData['email'] = $email;
$insData['aadhaar'] = $aadhaar;
$insData['pan'] = $pan;
$insData['address'] = $address;
$insData['pin'] = $pin;
$insData['state'] = $state;
$insData['balance'] = 0;
//$insData['psa_id'] = NULL;
$insData['uti_active'] = "NO";
$insData['nsdl_active'] = "NO";
$insData['recharge_active'] = "NO";
$insData['gateway'] = "OFF";
$insData['smartgateway'] = "ON";
$insData['plan_id'] = $plan_id;
$insData['created_at'] = current_timestamp();
$insData['remark'] = "";
$insData['status'] = "Unpaid";
$insertId = db_insert("members", $insData);
if($insertId){
$token = aes_encrypt($insertId,$site_data['user_id']);
$activationLink = "{$site_data['protocol']}{$site_data['baseurl']}/alipay/selfactivation?token=$token";
$message = "Dear {$insData['name']}, Please activate your account by clicking the link below $activationLink";    
send_sms($insData['mobile'],$message);
send_mail($insData['email'],"Account Activation",$message); 
redirect($activationLink,0);
die("Please do not refresh this page...");
}else{
awal_alert_msg("Server is Error!",'info');  
}

}else{
awal_alert_msg("Username OR Mobile Already Exists!",'error');
}

}else{
awal_alert_msg("UserType Not Access!",'error');
}

}else{
awal_alert_msg("Please Fill All Valid Details!",'error');
}

}
?>

                <h1>Register</h1>
                <div class="group-input">
                    <label>Name</label>
                    <!--input type="text" value="Themesflat"-->
                    <input type="text" placeholder="Enter Name" name="name" required>
                </div>
                <div class="group-input">
                    <label>Shop Name</label>
                    <!--input type="text" value="Example@gmail"-->
                    <input type="text" placeholder="Enter Shop Name" name="company" required>
                </div>
                <div class="group-input">
                    <label>Mobile Numberr</label>
                    <!--input type="text" value="123 4567 890"-->
                    <input type="number" placeholder="Enter Mobile Number" name="mobile" onkeypress="if(this.value.length==10) return false;" required>
                </div>
                <div class="group-input">
                    <label>Email Address</label>
                    <!--input type="password" placeholder="6-20 characters"-->
                     <input type="emial" class="form-control" placeholder="Enter Email Address" name="email" required>
                </div>
                <div class="group-input">
                    <label>Aadhaar Number</label>
                    <!--input type="password" placeholder="6-20 characters"-->
                    <input type="number" placeholder="Enter Aadhaar Number" name="aadhaar" onkeypress="if(this.value.length==12) return false;" required>
                </div>
                <div class="group-input">
                    <label>PAN Number</label>
                    <!--input type="password" placeholder="6-20 characters"-->
                    <input type="text" placeholder="Enter PAN Number" name="pan" onkeypress="if(this.value.length==10) return false;" required>
                </div>
                <div class="group-input">
                    <label>Address</label>
                    <!--input type="password" placeholder="6-20 characters"-->
                    <input type="text" placeholder="Enter Address" name="address" onkeypress="if(this.value.length==35) return false;" required>
                </div>
                <div class="group-input">
                    <label>PIN Code</label>
                    <!--input type="password" placeholder="6-20 characters"-->
                    <input type="number"  placeholder="Enter PIN Code" name="pin" onkeypress="if(this.value.length==6) return false;" required>
                </div>
                <div class="group-input">
                    <label>State</label>
                    <select class="form-control" name="state" required>
                <option value="">--Select State--</option>
                <option value="1">ANDAMAN AND NICOBAR ISLANDS</option>
                <option value="2">ANDHRA PRADESH</option>
                <option value="3">ARUNACHAL PRADESH</option>
                <option value="4">ASSAM</option>
                <option value="5">BIHAR</option>
                <option value="6">CHANDIGARH</option>
                <option value="33">CHHATTISGARH</option>
                <option value="7">DADRA AND NAGAR HAVELI</option>
                <option value="8">DAMAN AND DIU</option>
                <option value="9">DELHI</option>
                <option value="10">GOA</option>
                <option value="11">GUJARAT</option>
                <option value="12">HARYANA</option>
                <option value="13">HIMACHAL PRADESH</option>
                <option value="14">JAMMU AND KASHMIR</option>
                <option value="35">JHARKHAND</option>
                <option value="15">KARNATAKA</option>
                <option value="16">KERALA</option>
                <option value="17">LAKSHADWEEP</option>
                <option value="18">MADHYA PRADESH</option>
                <option value="19">MAHARASHTRA</option>
                <option value="20">MANIPUR</option>
                <option value="21">MEGHALAYA</option>
                <option value="22">MIZORAM</option>
                <option value="23">NAGALAND</option>
                <option value="24">ODISHA</option>
                <option value="99">OTHER</option>
                <option value="25">PONDICHERRY</option>
                <option value="26">PUNJAB</option>
                <option value="27">RAJASTHAN</option>
                <option value="28">SIKKIM</option>
                <option value="29">TAMILNADU</option>
                <option value="36">TELANGANA</option>
                <option value="30">TRIPURA</option>
                <option value="31">UTTAR PRADESH</option>
                <option value="34">UTTARAKHAND</option>
                <option value="32">WEST BENGAL</option>
            </select>
                </div>
                <div class="group-input">
                <label>User Type</label>
                <select class="form-control" name="usertype" required>
                <option value="">Select</option>
                <option value="Retailer">Retailer</option>
                <option value="Distributor">Distributor</option>
                <option value="Master Distributor">Master Distributor</option>
               </select>
               </div>        
                    <div class="group-cb mt-5">
                     <input type="checkbox" checked class="tf-checkbox">
                    <label class="fw_3">I agree to <a>Terms and condition</a> </label> 
                </div>
                <button type="submit" class="tf-btn accent large" name="createaccount">Create An Account</button>
            </form>

        </div>
    </div>
    
  



    <script type="text/javascript" src="javascript/jquery.min.js"></script>
    <script type="text/javascript" src="javascript/bootstrap.min.js"></script>
    <script type="text/javascript" src="javascript/password-addon.js"></script>
    <script type="text/javascript" src="javascript/main.js"></script>
    <script type="text/javascript" src="javascript/init.js"></script>


</body>


</html>