<?php
require_once("autoload.php");
require_once("config.php");

function api_token_gen(){ 
return implode('-', str_split(substr(strtolower(md5(microtime().rand(1000, 9999))), 0, 30), 6));
}

function awal_alert_msg($msg,$type='primary',$redirect='javascript:void(0)'){
echo '
<script src="//code.jquery.com/jquery-3.4.1.min.js"></script>
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script>
$(document).ready(function () {
Swal.fire("'.$msg.'", "", "'.$type.'").then(function() { window.location = "'.$redirect.'"; });
});
</script>
';
}

function redirct_alert_msg($msg,$type='primary',$redirect='javascript:void(0)'){
  $msgg = base64_encode($msg);
  $rredirect=$redirect.'?m='.$msgg;
  echo '
  <script src="//code.jquery.com/jquery-3.4.1.min.js"></script>
  <script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
  <script>
  $(document).ready(function () {
  window.location = "'.$rredirect.'";
  });
  </script>
  ';
  }

function alert_msg($msg,$type='primary'){
echo '<div class="alert alert-'.$type.' alert-dismissible fade show"><i class="fa fa-bell fa-fw"></i> '.$msg.'</div>';
}


function alert_js($msg){
echo '<script>alert("'.$msg.'");</script>';
}

function data_table($value='#dataTable'){
echo '
<link rel="stylesheet" href="//cdn.datatables.net/1.13.1/css/dataTables.bootstrap4.min.css">
<style>
div.dataTables_wrapper div.dataTables_filter {
    padding: 1rem; 
}
div.dataTables_wrapper div.dataTables_length {
    text-align: left;
    padding: 1rem; 
}
div.dataTables_wrapper div.dataTables_paginate {
    padding-bottom: 1rem;
    padding-right: 1rem;
}
div.dataTables_wrapper div.dataTables_info {
    text-align: left;
    padding-left: 1rem;
}

.table-bordered {
  border: 1px solid #009cff !important;
}
</style>
<script src="//cdn.datatables.net/1.13.1/js/jquery.dataTables.min.js"></script>
<script src="//cdn.datatables.net/1.13.1/js/dataTables.bootstrap5.min.js"></script>
<script>
$(document).ready(function () {
    $("'.$value.'").DataTable();
});
</script>
';
}


function summernote($value='#summernote'){
echo '
<link href="//cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote-bs4.min.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/summernote@0.8.18/dist/summernote-bs4.min.js"></script>
<script>
$(document).ready(function () {
$( "'.$value.'" ).summernote({ placeholder: $( "'.$value.'" ).attr("placeholder"), height: 300 });
});
</script>
';
}


function datepicker($value='.datepicker'){
echo '
<link href="https://code.jquery.com/ui/1.12.1/themes/cupertino/jquery-ui.css" rel="stylesheet">
<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js" ></script>
<script>
$(document).ready(function () {
$( "'.$value.'" ).datepicker({
  dateFormat: "dd-mm-yy"
});
});
</script>
';
}


function modal($id,$type){
echo '
<script>
$(document).ready(function () {
$( "'.$id.'" ).modal("'.$type.'");
});
</script>
';
}

function _get($key){
return str_replace(['.php'," "],['','+'],$_GET[$key]);  
}

function get_query_value($key=false){
$parsed = parse_url($_SERVER['REQUEST_URI']);
$query = $parsed['query'];
parse_str($query, $params);
return $key==false ? $params : $params[$key];
}

function get_page_name(){
return substr(strtok($_SERVER['REQUEST_URI'], '?'),1);
}

function select2($id){
echo '
<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.2/css/select2.min.css" rel="stylesheet" />
<style>
.select2-container--default .select2-selection--single .select2-selection__rendered {
    color: #444;
    line-height: 1.5;
    margin-top: 7.5px;
}
.select2-container .select2-selection--single {
    height: calc(1.5em + 0.75rem + 2px);
}
.select2-container--default .select2-selection--single .select2-selection__arrow {
    height: 32px;
    position: absolute;
    top: 1px;
    right: 1px;
    width: 20px;
}
</style>
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.2/js/select2.min.js"></script>
<script>
$(document).ready(function() {
$("'.$id.'").select2({
    display: "block",
    width: "100%",
    allowClear: false,
    height: "calc(1.5em + .75rem + 2px)",
});
});
</script>';
}


function bootstrap($v=4,$fav=""){
if($v==3){
echo '
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="icon" href="'.$fav.'" type="image/*">
<link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">';	
}else if($v==4){
echo '
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="icon" href="'.$fav.'" type="image/*">
<link rel="stylesheet" href="//cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
';
}else if($v==5){
echo '
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="icon" href="'.$fav.'" type="image/*">
<link rel="stylesheet" href="//cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css">
<link rel="stylesheet" href="//cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">';	
}
}


function title($val){
echo '<title>'.$val.'</title>';
}



function file_name(){
return strtoupper(str_replace("_"," ",basename($_SERVER["SCRIPT_FILENAME"], '.php'))); 
}

function page_name(){
return ucwords(str_replace("_"," ",basename(parse_url($_SERVER["REQUEST_URI"], PHP_URL_PATH), '.html')));   
}



function imgbase64($image){  
if ($image !== false){
    return 'data:image/jpg;base64,'.base64_encode(file_get_contents($image));
} 
}

function getSateName($State){
    
switch ($State) {
        case "2":
        $StateName= "Andhra Pradesh";
        break;
        case "3":
        $StateName= "Arunachal Pradesh";
        break;
        case "4":
        $StateName= "Assam";
        break;
        case "5":
        $StateName= "Bihar";
        break;
        case "33":
        $StateName= "Chhattisgarh";
        break;
        case "10":
        $StateName= "Goa";
        break;
        case "11":
        $StateName= "Gujarat";
        break;
        case "12":
        $StateName= "Haryana";
        break;
        case "13":
        $StateName= "Himachal";
        break;
        case "14":
        $StateName= "Jammu";
        break;
        case "35":
        $StateName= "Jharkhand";
        break;
        case "15":
        $StateName= "Karnataka";
        break;
        case "16":
        $StateName= "Kerala";
        break;
        case "18":
        $StateName= "Madhya Pradesh";
        break;
        case "19":
        $StateName= "Maharashtra";
        break;
        case "20":
        $StateName= "Manipur";
        break;
        case "21":
        $StateName= "Meghalaya";
        break;
        case "22":
        $StateName= "Mizoram";
        break;
        case "24":
        $StateName= "Orissa";
        break;
        case "26":
        $StateName= "Punjab";
        break;
        case "27":
        $StateName= "Rajasthan";
        break;
        case "28":
        $StateName= "Sikkim";
        break;
        case "29":
        $StateName= "Tamil Nadu";
        break;
        case "30":
        $StateName= "Tripura";
        break;
        case "31":
        $StateName= "Uttar Pradesh";
        break;
        case "34":
        $StateName= "Uttarakhand";
        break;
        case "32":
        $StateName= "West Bengal";
        break;
        case "9":
        $StateName= "Delhi";
        break;
        case "6":
        $StateName= "Chandigarh";
        break;
        case "36":
        $StateName= "Telangana";
        break;
        default:
        $StateName= "";
        break;
}   

return strtoupper($StateName);    
}


function _ago($tm,$rcs = 0) {
$cur_tm = time(); 
$dif = $cur_tm-$tm;
$pds = array('second','minute','hour','day','week','month','year','decade');
$lngh = array(1,60,3600,86400,604800,2630880,31570560,315705600);

for($v = sizeof($lngh)-1; ($v >= 0)&&(($no = $dif/$lngh[$v])<=1); $v--); if($v < 0) $v = 0; $_tm = $cur_tm-($dif%$lngh[$v]);
    $no = floor($no);
    if($no <> 1)
        $pds[$v] .='s';
    $x = sprintf("%d %s ",$no,$pds[$v]);
    if(($rcs == 1)&&($v >= 1)&&(($cur_tm-$_tm) > 0))
        $x .= time_ago($_tm);
    return $x;
}

function current_timestamp(){
    return date("Y-m-d H:i:s");
}

function checkIPAddress($ipAddress) 
{
    return preg_match('/^(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)(?:[.](?:25[0-5]|2[0-4]\d|1\d\d|[1-9]\d|\d)){3}$/', $ipAddress);
}
require_once(".db.php");
function generateNumericOTP($n) { 
    $generator = "1357902468"; 
    $result = ""; 
  
    for ($i = 1; $i <= $n; $i++) { 
        $result .= substr($generator, (rand()%(strlen($generator))), 1); 
    } 
  
    // Return result 
    return $result; 
} 

function order_txn_id(){
 return date("ymdHis").generateNumericOTP(8);   
}

function generate_api_key(){
 $key = implode('-', str_split(substr(strtolower(md5(microtime().rand(1000, 9999))), 0, 30), 6));
return $key;
}

function safe_str($value){
    $search = array("\\",  "\x00", "\n",  "\r",  "'",  '"', "\x1a", "-","+","=");
    $replace = array("\\\\","\\0","\\n", "\\r", "\'", '\"', "\\Z", "","","");
    return strip_tags(str_replace($search, $replace, $value));
}

function safe_str_($value){
    $search = array("\\",  "\x00", "\n",  "\r",  "'",  '"', "\x1a", "_","+","=");
    $replace = array("\\\\","\\0","\\n", "\\r", "\'", '\"', "\\Z", " ","","");
    return strip_tags(str_replace($search, $replace, $value));
}

function space_remove($string){
    return strip_tags(preg_replace('/\s+/','',strip_tags(str_replace(' ', '', $string))));
}

function safe_clean($string) {
   $string = str_replace(' ', '-', $string); // Replaces all spaces with hyphens.
   $string = preg_replace('/[^A-Za-z0-9\- ]/', '', $string); // Removes special chars.

   return preg_replace('/-+/', '-', $string); // Replaces multiple hyphens with single one.
}

function divide($x,$y){
 return $x / $y;   
}

function real_escape_string(String $value){
$db = db();
$value = $db->escape_string(strip_tags($value));
$db->close(); 
return $value;
}


function is_valid_pincode($pincode){
if(is_numeric($pincode) && strlen($pincode)==6){
return $pincode;    
}
}

function is_valid_statecode($state){
if(is_numeric($state) && strlen($state)>0){
return $state;    
}
}

function is_valid_mobile($number){
if(is_numeric($number) && strlen($number)==10){
return $number;    
}
}


function is_valid_aadhaar($number){
if(is_numeric($number) && strlen($number)==12){
return $number;    
}
}

function is_valid_pan($number){
if(strlen($number)==10){
return $number;    
}
}


function is_valid_email($email){
if(filter_var($email, FILTER_VALIDATE_EMAIL)){
return $email;    
}
}

function is_valid_amount($amount){
if(is_numeric($amount)){
return safe_str($amount);    
}
}

function is_valid_usertype($usertype){
if(in_array($usertype, ['White Label','Master Distributor','Distributor','Retailer','Apipartner'])){
return $usertype;
}
}



function is_access_usertype($user_data,$usertype){
if(in_array($user_data['usertype'], ['Admin'])){
return in_array($usertype,['Master Distributor','Distributor','Retailer','Apipartner'])? $usertype : false;
}
else if(in_array($user_data['usertype'], ['Admin','White Label'])){
return in_array($usertype,['Master Distributor','Distributor','Retailer'])? $usertype : false;
}else if(in_array($user_data['usertype'], ['Master Distributor'])){
return in_array($usertype,['Distributor','Retailer'])? $usertype : false;
}else if(in_array($user_data['usertype'], ['Distributor'])){
return in_array($usertype,['Retailer'])? $usertype : false;
} 

}


function is_valid_url($url){
if(filter_var($url, FILTER_VALIDATE_URL)){
return $url;    
}
}


function is_base64_image($base64Img){
if(strtolower(explode("image",$base64Img)[0])=="data:") {
return $base64Img;    
}  
}


function get_safe($string){
   return strip_tags($string);
}

function pt($data){
echo "<pre>";
print_r($data);
echo "</pre>";
}

function redirect($url,$time){
echo '<script>
setTimeout(
function(){
window.location = "'.$url.'" 
},'.$time.');
</script>';
}

function redirect_blank($url,$time){
echo '<script>
setTimeout(
function(){
window.open("'.$url.'");
},'.$time.');
</script>';
}


function baseurl(){
 return str_replace("www.","",$_SERVER['SERVER_NAME']);
}

function StrReplace($str,$fnd,$rep){
return str_replace($fnd,$rep,$str);     
}


function user_ip(){
return $_SERVER['REMOTE_ADDR'];
}


function get_recharge_commission($amount,$commission){
$get = (100 - $commission);
$decimal = $get / 100;
return $decimal * $amount;
}


function get_recharge_parent_commission($amount,$commission){
$get= ($commission / 100);
return $get * $amount;  
}


function http_post($url,$post_data,$header=array()){
$curl = curl_init();
curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => $post_data,
  CURLOPT_HTTPHEADER => $header
));
$response = curl_exec($curl);
curl_close($curl);
return $response;
}

function http_get($url,$header=array(),$timeout=0,$ssl=false){
$curl = curl_init();
curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => $timeout,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => $header
));
$response = curl_exec($curl);

if($ssl==true){
curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
}
curl_close($curl);
return $response;
}

function db(){
global $dbhost, $dbuser, $dbpass, $dbname;
return new db($dbhost, $dbuser, $dbpass, $dbname);
}

function db_insert($tableName, $insData){
    $db = db();
    $columns = implode(", ",array_keys($insData));
    $escaped_values = array_map(array($db,"escape_string"), array_values($insData));
    foreach ($escaped_values as $idx=>$data) $escaped_values[$idx] = "'".$data."'";
    $values  = implode(", ", $escaped_values);
    $sql = "INSERT INTO $tableName ($columns) VALUES ($values)";
    $lastInsertID = $db->query($sql)->lastInsertID();
    $db->close(); 
    return $lastInsertID;
}


function db_update($tableName, $insData, $condition){
    $db = db();
    $sql = "UPDATE $tableName SET ";
    foreach($insData as $key=>$value) {
    $sql .= $key . " = '".$db->escape_string($value)."', "; 
    }
    $sql = trim($sql, ' ');
    $sql = trim($sql, ',');
    $sql .= " WHERE $condition";
    $affectedRows = $db->query($sql)->affectedRows();
    $db->close(); 
    return $affectedRows;
}


function db_fetch_array($tableName, $condition=false, $select="*"){
    $db = db();
    $sql = "SELECT $select FROM $tableName ";
    if($condition){
    $sql .= " WHERE $condition";
    }
    $fetchArray = $db->query($sql)->fetchArray();
    $db->close(); 
    return $fetchArray;
}



function db_fetch_all($tableName, $condition=false, $select="*"){
    $db = db();
    $sql = "SELECT $select FROM $tableName ";
    if($condition){
    $sql .= " WHERE $condition";
    }
    $fetchArray = $db->query($sql)->fetchAll();
    $db->close(); 
    return $fetchArray;
}



function db_describe($tableName){
    $db = db();
    $sql = "DESCRIBE $tableName ";
    $affectedRows = $db->query($sql)->fetchAll();
    $db->close(); 
    return $affectedRows;
}



function db_delete($tableName, $condition=false){
    $db = db();
    $sql = "DELETE FROM $tableName ";
    if($condition){
    $sql .= " WHERE $condition";
    }
    $affectedRows = $db->query($sql)->affectedRows();
    $db->close(); 
    return $affectedRows;
}


function my_plan_data($user_data){
 return db_fetch_array("marginslab"," plan_id='".$user_data['plan_id']."' ");
}



function get_username($data){
 return $data;
}


function get_agent_id($pan,$mobile){
 return substr($pan,0,4).substr($mobile,4);
}

function get_vle_id($pan,$mobile){
 return apis("botapi_prefix").'-'.substr($pan,0,4).substr($mobile,4);
}

function site_data(){
$db = db();
$result = $db->query("SELECT * FROM `sitedata` WHERE baseurl='".baseurl()."' ")->fetchArray();
$db->close(); 
return $result;    
}

function main_site_data(){
$db = db();
$result = $db->query("SELECT * FROM `sitedata` WHERE site_id='1' ")->fetchArray();
$db->close(); 
return $result;    
}

function apis($type){
  global $main_site_data;  
  return json_decode($main_site_data['apis'],true)[$type];
}


function paymentapi($type){
  global $main_site_data;  
  return json_decode($main_site_data['paymentapi'],true)[$type];
}

function smsapi($type){
  global $site_data;  
  return json_decode($site_data['smsapi'],true)[$type];
}


function smtp($type){
  global $site_data;  
  return json_decode($site_data['smtp'],true)[$type];
}


function aes_encrypt($string,$password){
  return base64_encode(openssl_encrypt($string,"AES-128-ECB",$password));
}

function aes_256_encrypt($text, $passphrase)
{
 $salt = openssl_random_pseudo_bytes(8);
 $salted = $dx = "";
 while (strlen($salted) < 48) {
 $dx = md5($dx . $passphrase . $salt, true);
 $salted .= $dx;
 }
 $key = substr($salted, 0, 32);
 $iv = substr($salted, 32, 16);
 return base64_encode(
 "Salted__" .
 $salt .
 openssl_encrypt(
 $text . "",
 "aes-256-cbc",
 $key,
 OPENSSL_RAW_DATA,
 $iv
 )
 );
}

function aes_decrypt($encrypted,$password){
  return openssl_decrypt(base64_decode($encrypted),"AES-128-ECB",$password); 
}


function send_sms($number,$message){
$smsapi_url = smsapi("url");    
$message = urlencode($message);  
$find  = array("{NUMBER}","{MSG}");
$repls  = array($number,$message);
$url = StrReplace($smsapi_url,$find,$repls);
$response = http_get($url,[],30,true);
return $response;
}

function send_mail($email,$subject,$message) {
require_once('class.phpmailer.php');
require_once('class.smtp.php');

$mail=new PHPMailer();
$mail->IsSMTP();
$mail->Host=smtp("host");
$mail->Port=smtp("port");
$mail->SMTPSecure=smtp("protocol");
$mail->SMTPAuth=true;
$mail->Username=smtp("username");
$mail->Password=smtp("password");
$mail->SetFrom($mail->Username,smtp("sender"));
$mail->addAddress($email);
$mail->IsHTML(true);
$mail->Subject=$subject;
$mail->Body=$message;
$mail->SMTPOptions=array('tls'=>array(
'verify_peer'=>false,
'verify_peer_name'=>false,
'allow_self_signed'=>true
));

return $mail->send();    
}

function login(String $username, String $password){
$db = db();
$username = $db->escape_string(safe_str($username));
$password = $db->escape_string($password);
$members = $db->query("SELECT * FROM `members` WHERE username='".$username."' and password='".$password."' ")->fetchArray();
$result = array("status"=>false,"is_otp"=>"NO","login_token"=>md5(time()));  
if($members['user_id']>0 && $members['username']==$username && $members['password']==$password){
$login_otp = generateNumericOTP(6);

$login_token = md5($login_otp);
if($members['usertype']=="Admin"){
$login_token = md5($members['username']);    
}

if($db->query("UPDATE `members` SET login_token='".$login_token."', login_otp='".$login_otp."' WHERE user_id='".$members['user_id']."' ")->affectedRows()){

if($members['is_otp']=="YES"){
$message = "Dear {$members['name']}, Your Login OTP is: {$login_otp} Please do not share this OTP anyone. https://".baseurl();    
send_sms($members['mobile'],$message);
send_mail($members['email'],"Your Login OTP",$message);
}else{
$user_ip = user_ip();
$message = "Dear {$members['name']}, You have accessed {$members['username']} Account? And Login IP is: {$user_ip}, if not please change your password immediately. https://".baseurl();    
//send_sms($members['mobile'],$message);
//send_mail($members['email'],"User Login Details",$message);   
}


$result = array("status"=>true,"is_otp"=>$members['is_otp'],"login_token"=>$login_token);    
}

}
$db->close();   
return $result;
}


function login_otp_verify(String $login_token, Int $login_otp){
$db = db();
$login_token = $db->escape_string($login_token);
$members = $db->query("SELECT * FROM `members` WHERE login_token='".$login_token."' ")->fetchArray();
$result = array("status"=>false,"login_token"=>md5(time()));  
if($members['user_id']>0 && $members['login_token']==$login_token && $members['login_otp']==$login_otp){
$login_token = md5($login_token);
if($members['usertype']=="Admin"){
$login_token = md5($members['username']);    
}
$login_otp = generateNumericOTP(4);
if($db->query("UPDATE `members` SET login_token='".$login_token."', login_otp='".$login_otp."' WHERE user_id='".$members['user_id']."' ")->affectedRows()){

$user_ip = user_ip();
$message = "Dear {$members['name']}, You have accessed {$members['username']} Account? And Login IP is: {$user_ip}, if not please change your password immediately. https://".baseurl();    
//send_sms($members['mobile'],$message);    
//send_mail($members['email'],"User Login Details",$message);
$result = array("status"=>true,"login_token"=>$login_token);    
}

}
$db->close();   
return $result;
}



function forgotpassword(String $username){
$db = db();
$username = $db->escape_string(safe_str($username));
$members = $db->query("SELECT * FROM `members` WHERE username='".$username."' ")->fetchArray();
$result = array("status"=>false);  
if($members['user_id']>0 && $members['username']==$username && $members['usertype']!="Admin"){
$password = generateNumericOTP(6);
if($db->query("UPDATE `members` SET password='".$password."', is_otp='YES' WHERE user_id='".$members['user_id']."' ")->affectedRows()){
$message = "Dear {$members['name']}, Your New Password: {$password} Login https://".baseurl();    
send_sms($members['mobile'],$message);
send_mail($members['email'],"Login Password",$message);  
$result = array("status"=>true);    
}
}
$db->close();   
return $result;
}


function user_data(String $login_token){
global $dbhost, $dbuser, $dbpass, $dbname;
$db = new db($dbhost, $dbuser, $dbpass, $dbname);
$login_token = $db->escape_string($login_token);
$members = $db->query("SELECT * FROM `members` WHERE login_token='".$login_token."' ")->fetchArray();
$db->close();   
return $members;
}


function pan_commission_credit($user_data,$app_mode,$data){
global $site_data;
if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$user_plan = my_plan_data($user_data);

$parent1 = array();
$parent1_plan = array();
$parent2 = array();
$parent2_plan = array();
$parent3 = array();
$parent3_plan = array();
$parent4 = array();
$parent4_plan = array();
$parent5 = array();
$parent5_plan = array();


if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$parent1 = db_fetch_array("members", " user_id='".$user_data['parent_id']."' ");  
if($parent1['user_id']>0){
$parent1_plan = my_plan_data($parent1);

$commission = ($user_plan[$app_mode] - $parent1_plan[$app_mode]);
if($commission>0){

$old_balance = $parent1['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent1['site_id'];
$insData['user_id'] = $parent1['user_id'];
$insData['username'] = $parent1['username'];
$insData['parent_id'] = $parent1['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Application {$user_data['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent1['user_id']."' ");
}
}
}
}


if($parent1['parent_id']>0 && $parent1['parent_id']!=$parent1['user_id']){
$parent2 = db_fetch_array("members", " user_id='".$parent1['parent_id']."' ");   
if($parent2['user_id']>0){
$parent2_plan = my_plan_data($parent2);   

$commission = ($parent1_plan[$app_mode] - $parent2_plan[$app_mode]);
if($commission>0){

$old_balance = $parent2['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent2['site_id'];
$insData['user_id'] = $parent2['user_id'];
$insData['username'] = $parent2['username'];
$insData['parent_id'] = $parent2['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Application {$parent1['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent2['user_id']."' ");
}
}
}
}


if($parent2['parent_id']>0 && $parent2['parent_id']!=$parent2['user_id']){
$parent3 = db_fetch_array("members", " user_id='".$parent2['parent_id']."' ");   
if($parent3['user_id']>0){
$parent3_plan = my_plan_data($parent3); 

$commission = ($parent2_plan[$app_mode] - $parent3_plan[$app_mode]);
if($commission>0){

$old_balance = $parent3['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent3['site_id'];
$insData['user_id'] = $parent3['user_id'];
$insData['username'] = $parent3['username'];
$insData['parent_id'] = $parent3['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Application {$parent2['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent3['user_id']."' ");
}
}  
}
}

if($parent3['parent_id']>0 && $parent3['parent_id']!=$parent3['user_id']){
$parent4 = db_fetch_array("members", " user_id='".$parent3['parent_id']."' "); 
if($parent4['user_id']>0){  
$parent4_plan = my_plan_data($parent4); 

$commission = ($parent3_plan[$app_mode] - $parent4_plan[$app_mode]);
if($commission>0){

$old_balance = $parent4['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent4['site_id'];
$insData['user_id'] = $parent4['user_id'];
$insData['username'] = $parent4['username'];
$insData['parent_id'] = $parent4['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Application {$parent3['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent4['user_id']."' ");
}
}  
}
}


if($parent4['parent_id']>0 && $parent4['parent_id']!=$parent4['user_id']){
$parent5 = db_fetch_array("members", " user_id='".$parent4['parent_id']."' "); 
if($parent5['user_id']>0){  
$parent5_plan = my_plan_data($parent5);  

$commission = ($parent4_plan[$app_mode] - $parent5_plan[$app_mode]);
if($commission>0){

$old_balance = $parent5['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent5['site_id'];
$insData['user_id'] = $parent5['user_id'];
$insData['username'] = $parent5['username'];
$insData['parent_id'] = $parent5['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Application {$parent4['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent5['user_id']."' ");
}
} 
}
}


}
}



function pan_commission_debit($txn_id){
global $site_data;
$commissionreports = db_fetch_all("reports", " txn_id='".$txn_id."' AND operator='Commission' AND type='Credit' AND status='Success' ");  
foreach ($commissionreports as $key => $value) {
$user_data = db_fetch_array("members", " user_id='".$value['user_id']."' ");
$commission = $value['main_amount'];
if($commission>0){
$old_balance = $user_data['balance'];
$new_balance = $old_balance - $commission;

$insData = array();
$insData['site_id'] = $user_data['site_id'];
$insData['user_id'] = $user_data['user_id'];
$insData['username'] = $user_data['username'];
$insData['parent_id'] = $user_data['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Debit";
$insData['account_number'] = $value['account_number'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $value['txn_id'];
$insData['ref_id'] = $value['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Debit for Incomplete PAN Application";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$user_data['user_id']."' ");
db_update("reports", ["status"=>"Reversal"], " id='".$value['id']."' ");
}
}
}
}



function panfind_commission_credit($user_data,$app_mode,$data){
global $site_data;
if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$user_plan = my_plan_data($user_data);

$parent1 = array();
$parent1_plan = array();
$parent2 = array();
$parent2_plan = array();
$parent3 = array();
$parent3_plan = array();
$parent4 = array();
$parent4_plan = array();
$parent5 = array();
$parent5_plan = array();


if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$parent1 = db_fetch_array("members", " user_id='".$user_data['parent_id']."' ");  
if($parent1['user_id']>0){
$parent1_plan = my_plan_data($parent1);

$commission = ($user_plan[$app_mode] - $parent1_plan[$app_mode]);
if($commission>0){

$old_balance = $parent1['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent1['site_id'];
$insData['user_id'] = $parent1['user_id'];
$insData['username'] = $parent1['username'];
$insData['parent_id'] = $parent1['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Find {$user_data['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent1['user_id']."' ");
}
}
}
}


if($parent1['parent_id']>0 && $parent1['parent_id']!=$parent1['user_id']){
$parent2 = db_fetch_array("members", " user_id='".$parent1['parent_id']."' ");   
if($parent2['user_id']>0){
$parent2_plan = my_plan_data($parent2);   

$commission = ($parent1_plan[$app_mode] - $parent2_plan[$app_mode]);
if($commission>0){

$old_balance = $parent2['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent2['site_id'];
$insData['user_id'] = $parent2['user_id'];
$insData['username'] = $parent2['username'];
$insData['parent_id'] = $parent2['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Find {$parent1['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent2['user_id']."' ");
}
}
}
}


if($parent2['parent_id']>0 && $parent2['parent_id']!=$parent2['user_id']){
$parent3 = db_fetch_array("members", " user_id='".$parent2['parent_id']."' ");   
if($parent3['user_id']>0){
$parent3_plan = my_plan_data($parent3); 

$commission = ($parent2_plan[$app_mode] - $parent3_plan[$app_mode]);
if($commission>0){

$old_balance = $parent3['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent3['site_id'];
$insData['user_id'] = $parent3['user_id'];
$insData['username'] = $parent3['username'];
$insData['parent_id'] = $parent3['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Find {$parent2['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent3['user_id']."' ");
}
}  
}
}

if($parent3['parent_id']>0 && $parent3['parent_id']!=$parent3['user_id']){
$parent4 = db_fetch_array("members", " user_id='".$parent3['parent_id']."' "); 
if($parent4['user_id']>0){  
$parent4_plan = my_plan_data($parent4); 

$commission = ($parent3_plan[$app_mode] - $parent4_plan[$app_mode]);
if($commission>0){

$old_balance = $parent4['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent4['site_id'];
$insData['user_id'] = $parent4['user_id'];
$insData['username'] = $parent4['username'];
$insData['parent_id'] = $parent4['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Find {$parent3['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent4['user_id']."' ");
}
}  
}
}


if($parent4['parent_id']>0 && $parent4['parent_id']!=$parent4['user_id']){
$parent5 = db_fetch_array("members", " user_id='".$parent4['parent_id']."' "); 
if($parent5['user_id']>0){  
$parent5_plan = my_plan_data($parent5);  

$commission = ($parent4_plan[$app_mode] - $parent5_plan[$app_mode]);
if($commission>0){

$old_balance = $parent5['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent5['site_id'];
$insData['user_id'] = $parent5['user_id'];
$insData['username'] = $parent5['username'];
$insData['parent_id'] = $parent5['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For PAN Find {$parent4['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent5['user_id']."' ");
}
} 
}
}


}
}



function panfind_commission_debit($txn_id){
global $site_data;
$commissionreports = db_fetch_all("reports", " txn_id='".$txn_id."' AND operator='Commission' AND type='Credit' AND status='Success' ");  
foreach ($commissionreports as $key => $value) {
$user_data = db_fetch_array("members", " user_id='".$value['user_id']."' ");
$commission = $value['main_amount'];
if($commission>0){
$old_balance = $user_data['balance'];
$new_balance = $old_balance - $commission;

$insData = array();
$insData['site_id'] = $user_data['site_id'];
$insData['user_id'] = $user_data['user_id'];
$insData['username'] = $user_data['username'];
$insData['parent_id'] = $user_data['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Debit";
$insData['account_number'] = $value['account_number'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $value['txn_id'];
$insData['ref_id'] = $value['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Debit for Failed PAN Find";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$user_data['user_id']."' ");
db_update("reports", ["status"=>"Reversal"], " id='".$value['id']."' ");
}
}
}
}

function recharge_commission_credit($user_data,$app_mode,$data){
global $site_data;
if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$user_plan = my_plan_data($user_data);
$amount = $data['amount'];
$parent1 = array();
$parent1_plan = array();
$parent2 = array();
$parent2_plan = array();
$parent3 = array();
$parent3_plan = array();
$parent4 = array();
$parent4_plan = array();
$parent5 = array();
$parent5_plan = array();


if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$parent1 = db_fetch_array("members", " user_id='".$user_data['parent_id']."' ");  
if($parent1['user_id']>0){
$parent1_plan = my_plan_data($parent1);

$commission = ($parent1_plan[$app_mode] - $user_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent1['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent1['site_id'];
$insData['user_id'] = $parent1['user_id'];
$insData['username'] = $parent1['username'];
$insData['parent_id'] = $parent1['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Recharge {$user_data['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent1['user_id']."' ");
}
}
}
}


if($parent1['parent_id']>0 && $parent1['parent_id']!=$parent1['user_id']){
$parent2 = db_fetch_array("members", " user_id='".$parent1['parent_id']."' ");   
if($parent2['user_id']>0){
$parent2_plan = my_plan_data($parent2);   

$commission = ($parent2_plan[$app_mode] - $parent1_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent2['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent2['site_id'];
$insData['user_id'] = $parent2['user_id'];
$insData['username'] = $parent2['username'];
$insData['parent_id'] = $parent2['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Recharge {$parent1['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent2['user_id']."' ");
}
}
}
}


if($parent2['parent_id']>0 && $parent2['parent_id']!=$parent2['user_id']){
$parent3 = db_fetch_array("members", " user_id='".$parent2['parent_id']."' ");   
if($parent3['user_id']>0){
$parent3_plan = my_plan_data($parent3); 

$commission = ($parent3_plan[$app_mode] - $parent2_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent3['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent3['site_id'];
$insData['user_id'] = $parent3['user_id'];
$insData['username'] = $parent3['username'];
$insData['parent_id'] = $parent3['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Recharge {$parent2['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent3['user_id']."' ");
}
}  
}
}

if($parent3['parent_id']>0 && $parent3['parent_id']!=$parent3['user_id']){
$parent4 = db_fetch_array("members", " user_id='".$parent3['parent_id']."' "); 
if($parent4['user_id']>0){  
$parent4_plan = my_plan_data($parent4); 

$commission = ($parent4_plan[$app_mode] - $parent3_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent4['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent4['site_id'];
$insData['user_id'] = $parent4['user_id'];
$insData['username'] = $parent4['username'];
$insData['parent_id'] = $parent4['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Recharge {$parent3['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent4['user_id']."' ");
}
}  
}
}


if($parent4['parent_id']>0 && $parent4['parent_id']!=$parent4['user_id']){
$parent5 = db_fetch_array("members", " user_id='".$parent4['parent_id']."' "); 
if($parent5['user_id']>0){  
$parent5_plan = my_plan_data($parent5);  

$commission = ($parent5_plan[$app_mode] - $parent4_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent5['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent5['site_id'];
$insData['user_id'] = $parent5['user_id'];
$insData['username'] = $parent5['username'];
$insData['parent_id'] = $parent5['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Recharge {$parent4['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent5['user_id']."' ");
}
} 
}
}


}
}

function insurance_commission_credit($user_data,$app_mode,$data){
global $site_data;
if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$user_plan = my_plan_data($user_data);
$amount = $data['amount'];
$parent1 = array();
$parent1_plan = array();
$parent2 = array();
$parent2_plan = array();
$parent3 = array();
$parent3_plan = array();
$parent4 = array();
$parent4_plan = array();
$parent5 = array();
$parent5_plan = array();


if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$parent1 = db_fetch_array("members", " user_id='".$user_data['parent_id']."' ");  
if($parent1['user_id']>0){
$parent1_plan = my_plan_data($parent1);

$commission = ($parent1_plan[$app_mode] - $user_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent1['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent1['site_id'];
$insData['user_id'] = $parent1['user_id'];
$insData['username'] = $parent1['username'];
$insData['parent_id'] = $parent1['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Insurance {$user_data['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent1['user_id']."' ");
}
}
}
}


if($parent1['parent_id']>0 && $parent1['parent_id']!=$parent1['user_id']){
$parent2 = db_fetch_array("members", " user_id='".$parent1['parent_id']."' ");   
if($parent2['user_id']>0){
$parent2_plan = my_plan_data($parent2);   

$commission = ($parent2_plan[$app_mode] - $parent1_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent2['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent2['site_id'];
$insData['user_id'] = $parent2['user_id'];
$insData['username'] = $parent2['username'];
$insData['parent_id'] = $parent2['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Insurance {$parent1['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent2['user_id']."' ");
}
}
}
}


if($parent2['parent_id']>0 && $parent2['parent_id']!=$parent2['user_id']){
$parent3 = db_fetch_array("members", " user_id='".$parent2['parent_id']."' ");   
if($parent3['user_id']>0){
$parent3_plan = my_plan_data($parent3); 

$commission = ($parent3_plan[$app_mode] - $parent2_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent3['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent3['site_id'];
$insData['user_id'] = $parent3['user_id'];
$insData['username'] = $parent3['username'];
$insData['parent_id'] = $parent3['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Insurance {$parent2['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent3['user_id']."' ");
}
}  
}
}

if($parent3['parent_id']>0 && $parent3['parent_id']!=$parent3['user_id']){
$parent4 = db_fetch_array("members", " user_id='".$parent3['parent_id']."' "); 
if($parent4['user_id']>0){  
$parent4_plan = my_plan_data($parent4); 

$commission = ($parent4_plan[$app_mode] - $parent3_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent4['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent4['site_id'];
$insData['user_id'] = $parent4['user_id'];
$insData['username'] = $parent4['username'];
$insData['parent_id'] = $parent4['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Insurance {$parent3['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent4['user_id']."' ");
}
}  
}
}


if($parent4['parent_id']>0 && $parent4['parent_id']!=$parent4['user_id']){
$parent5 = db_fetch_array("members", " user_id='".$parent4['parent_id']."' "); 
if($parent5['user_id']>0){  
$parent5_plan = my_plan_data($parent5);  

$commission = ($parent5_plan[$app_mode] - $parent4_plan[$app_mode]);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent5['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent5['site_id'];
$insData['user_id'] = $parent5['user_id'];
$insData['username'] = $parent5['username'];
$insData['parent_id'] = $parent5['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For Insurance {$parent4['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent5['user_id']."' ");
}
} 
}
}


}
}

function elctricity_commission_credit($user_data,$app_mode,$data){
global $site_data;
if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$user_plan = my_plan_data($user_data);
$amount = $data['amount'];
$parent1 = array();
$parent1_plan = array();
$parent2 = array();
$parent2_plan = array();
$parent3 = array();
$parent3_plan = array();
$parent4 = array();
$parent4_plan = array();
$parent5 = array();
$parent5_plan = array();


if($user_data['parent_id']>0 && $user_data['parent_id']!=$user_data['user_id']){
$parent1 = db_fetch_array("members", " user_id='".$user_data['parent_id']."' ");  
if($parent1['user_id']>0){
$parent1_plan = my_plan_data($parent1);

$commission = ($parent1_plan['electricity'] - $user_plan['electricity']);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent1['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent1['site_id'];
$insData['user_id'] = $parent1['user_id'];
$insData['username'] = $parent1['username'];
$insData['parent_id'] = $parent1['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For electricity {$user_data['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent1['user_id']."' ");
}
}
}
}


if($parent1['parent_id']>0 && $parent1['parent_id']!=$parent1['user_id']){
$parent2 = db_fetch_array("members", " user_id='".$parent1['parent_id']."' ");   
if($parent2['user_id']>0){
$parent2_plan = my_plan_data($parent2);   

$commission = ($parent2_plan['electricity'] - $parent1_plan['electricity']);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent2['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent2['site_id'];
$insData['user_id'] = $parent2['user_id'];
$insData['username'] = $parent2['username'];
$insData['parent_id'] = $parent2['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For electricity {$parent1['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent2['user_id']."' ");
}
}
}
}


if($parent2['parent_id']>0 && $parent2['parent_id']!=$parent2['user_id']){
$parent3 = db_fetch_array("members", " user_id='".$parent2['parent_id']."' ");   
if($parent3['user_id']>0){
$parent3_plan = my_plan_data($parent3); 

$commission = ($parent3_plan['electricity'] - $parent2_plan['electricity']);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent3['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent3['site_id'];
$insData['user_id'] = $parent3['user_id'];
$insData['username'] = $parent3['username'];
$insData['parent_id'] = $parent3['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For electricity {$parent2['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent3['user_id']."' ");
}
}  
}
}

if($parent3['parent_id']>0 && $parent3['parent_id']!=$parent3['user_id']){
$parent4 = db_fetch_array("members", " user_id='".$parent3['parent_id']."' "); 
if($parent4['user_id']>0){  
$parent4_plan = my_plan_data($parent4); 

$commission = ($parent4_plan['electricity'] - $parent3_plan['electricity']);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent4['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent4['site_id'];
$insData['user_id'] = $parent4['user_id'];
$insData['username'] = $parent4['username'];
$insData['parent_id'] = $parent4['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For electricity {$parent3['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent4['user_id']."' ");
}
}  
}
}


if($parent4['parent_id']>0 && $parent4['parent_id']!=$parent4['user_id']){
$parent5 = db_fetch_array("members", " user_id='".$parent4['parent_id']."' "); 
if($parent5['user_id']>0){  
$parent5_plan = my_plan_data($parent5);  

$commission = ($parent5_plan['electricity'] - $parent4_plan['electricity']);
$commission = get_recharge_parent_commission($amount,$commission);
if($commission>0){

$old_balance = $parent5['balance'];
$new_balance = $old_balance + $commission;

$insData = array();
$insData['site_id'] = $parent5['site_id'];
$insData['user_id'] = $parent5['user_id'];
$insData['username'] = $parent5['username'];
$insData['parent_id'] = $parent5['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Credit";
$insData['account_number'] = $user_data['mobile'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $data['order_id'];
$insData['ref_id'] = $data['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Received For electricity {$parent4['username']}";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$parent5['user_id']."' ");
}
} 
}
}


}
}

function recharge_commission_debit($txn_id){
global $site_data;
$commissionreports = db_fetch_all("reports", " txn_id='".$txn_id."' AND operator='Commission' AND type='Credit' AND status='Success' ");  
foreach ($commissionreports as $key => $value) {
$user_data = db_fetch_array("members", " user_id='".$value['user_id']."' ");
$commission = $value['main_amount'];
if($commission>0){
$old_balance = $user_data['balance'];
$new_balance = $old_balance - $commission;

$insData = array();
$insData['site_id'] = $user_data['site_id'];
$insData['user_id'] = $user_data['user_id'];
$insData['username'] = $user_data['username'];
$insData['parent_id'] = $user_data['parent_id'];
$insData['order_id'] = order_txn_id();
$insData['service'] = "WALLET";
$insData['type'] = "Debit";
$insData['account_number'] = $value['account_number'];
$insData['operator'] = "Commission";
$insData['amount'] = $commission;
$insData['main_amount'] = $commission;
$insData['old_balance'] = $old_balance;
$insData['new_balance'] = $new_balance;
$insData['txn_id'] = $value['txn_id'];
$insData['ref_id'] = $value['ref_id'];
$insData['description'] = "Rs.{$commission} Commission Debit for Recharge";
$insData['date_time'] = current_timestamp();
$insData['status'] = "Success";
if(db_insert("reports", $insData)){
db_update("members", ["balance"=>$new_balance], " user_id='".$user_data['user_id']."' ");
db_update("reports", ["status"=>"Reversal"], " id='".$value['id']."' ");
}
}
}
}

function uti_onbording($user_data){

$agent_id = get_agent_id($user_data['pan'],$user_data['mobile']);
$post_data = json_encode([
  "token" => apis("panapi_token"),
  "name" => $user_data['name'],
  "agent_id" => $agent_id,
  "mobile" => $user_data['mobile'],
  "email_id" => $user_data['email'],
  "address" => $user_data['address'],
  "state" => getSateName($user_data['state']),
  "city" => $user_data['address'],
  "pincode" => $user_data['pin'],
  "pan_no" => $user_data['pan'],
  "aadhaar_no" => $user_data['aadhaar'],
]); 

$resJson = http_post("https://easysmart.in/app/api/agent/onbording",$post_data,["Content-Type: application/json"]);
$response = json_decode($resJson,true);
if($response['status']=="Success"){
if(db_update("members", ["psa_id"=>$agent_id,"psa_active"=>"YES","status"=>"Active"], " user_id='".$user_data['user_id']."' ")){  
$output = array("status"=>true,"message"=>"Agent Onbording Successfully");
}
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}

return $output;

}



function uti_login($user_data){
$post_data = json_encode([
  "token" => apis("panapi_token"),
  "agent_id" => $user_data['psa_id'],
  "req_type" => "LIVE",
]); 
$resJson = http_post("https://easysmart.in/app/api/uti/login",$post_data,["Content-Type: application/json"]);
$response = json_decode($resJson,true);
if($response['status']=="Success"){
$output = array("status"=>true,"message"=>"Login URL Generated Successfully","txn_id"=>$response['txn_id'],"url"=>$response['url']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}


function uti_debit_amt($postData,$my_plan_data){
if($postData['amount']>100){

$app_mode = "p_uti";
$kyc_charges = 2.5;
if ($postData['data']['PANApplMode'] == 'P') {
$amount = $my_plan_data['p_uti'];
}else{
$amount = ($my_plan_data['p_uti'] + $kyc_charges);
}

}else if($postData['amount']<90){

$app_mode = "e_uti";
$kyc_charges = 2.5;
if ($postData['data']['PANApplMode'] == 'P') {
$amount = $my_plan_data['e_uti'];
}else{
$amount = ($my_plan_data['e_uti'] + $kyc_charges);
}

}else{
$amount = 0;
$app_mode = "";
}

return array("amount"=>$amount,"app_mode"=>$app_mode);
}



function nsdl_request($post_data){
$resJson = http_post("https://easysmart.in/app/api/nsdl/request",$post_data,["Content-Type: application/json"]);
$response = json_decode($resJson,true);
if($response['status']=="Success"){
$output = array("status"=>true,"message"=>"Form Generated Successfully","txnid"=>$response['txnid'],"enc_data"=>$response['enc_data'],"url"=>$response['url']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}


function array_keys_replace($array, $replacement_keys)  {
      return array_combine($replacement_keys, array_values($array));
}

function build_http_query( $query ){

    $query_array = array();

    foreach( $query as $key => $key_value ){

        $query_array[] = $key. '=' .$key_value;

    }

    return implode( '&', $query_array );

}

function api_response_json($response,$arr){
 $ParentKey = explode("|",$arr['key']['ParentKey']); 
 if(!empty($arr['key']['ParentKey'])){
 $response = json_decode($response,true);
 foreach($ParentKey as $k => $v){
  if(!empty($v)){
  $response = $response[$v];
  }
 }
 $response = json_encode($response); 
 }
 
 $result = json_decode(str_replace(array_values($arr['key']),array_keys($arr['key']),$response));
 $result->Status = api_status($result->Status,$arr);
 return $result;
}

function api_status($val,$arr) {   

return str_replace(array_values($arr['value']),array_keys($arr['value']),$val);

}


function string_replace($str,$find,$replace) {   
 return str_replace($find,$replace,$str);
}


function recursive_change_key($arr, $set) {
        if (is_array($arr) && is_array($set)) {
            $newArr = array();
            foreach ($arr as $k => $v) {
                $key = array_key_exists( $k, $set) ? $set[$k] : $k;
                $newArr[$key] = is_array($v) ? recursive_change_key($v, $set) : $v;
            }
            return $newArr;
        }
        return $arr;    
}

function api_response_text($response,$arr,$separate=","){
$array = explode($separate,$response);
$people = array(); 
foreach($arr['key'] as $x => $val) {
  $people[] = recursive_change_key($array, array($val=>$x));
}



$newarr = array();
foreach($people as $x => $val) {
foreach($val as $x => $val) {
 if(is_string($x)){
   $newarr[$x] = $val;  
 }
}
}

 $result = json_decode(json_encode($newarr));
 $result->Status = api_status($result->Status,$arr);
 return $result;
}


class HttpRequest{
 
    public static function post($url,$postdata,$header=array(),$ssl=true){
   
		$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL => $url,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => '',
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => 'POST',
		  CURLOPT_POSTFIELDS => $postdata,
		  CURLOPT_HTTPHEADER => $header,
		));

    if($ssl==false){
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    }

		$response = curl_exec($curl);
		curl_close($curl); 
		return $response;
	}	
	

    public static function get($url,$timeout=0){

		$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL =>$url,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => $timeout,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "GET",
		));

		$response = curl_exec($curl);
		$err = curl_error($curl);
		curl_close($curl); 
		return $response;
	}	
  
}


function get_operator_list($operator_type){
return db_fetch_all("operators", " operator_type='".$operator_type."' AND status='1' ");
}


function get_operator_by_id($operator_id){
return db_fetch_array("operators", " operator_id='".$operator_id."' AND status='1' ");
}

function get_api_operator_id($operator_id,$api_id){
return db_fetch_array("api_operators", " api_id='".$api_id."' AND operator_id='".$operator_id."' AND is_active='1' ")['api_operator_id'];
}


function apis_deatils($api_id){
return db_fetch_array("apis_deatils", " api_id='".$api_id."' and is_active='1' ");
}


function send_recharge_api($accountnumber,$operator_id,$amount,$order_id,$api_id){
$result = array();   
$apis_array = apis_deatils($api_id);
if(count($apis_array) && in_array($apis_array['api_type'],array("Recharge"))){
  
$request = json_decode($apis_array['recharge_parameter'],true);


$Api_Key = $apis_array['api_key'];
$Username = $apis_array['api_username'];
$Password = $apis_array['api_password'];
$Mobile = $accountnumber;
$Operator = get_api_operator_id($operator_id,$apis_array['api_id']);
$Amount = $amount;
$OrderID = $order_id;

$apis_value = array(
'Api_Key'   => $Api_Key,
'Username'  => $Username,
'Password'  => $Password,
'Mobile'    => $Mobile,
'Operator'  => $Operator,
'Amount'    => $Amount,
'OrderID'   => $OrderID,
"Optional1" => "",
"Optional2" => "",
"Optional3" => "",
"Optional4" => "",
"Optional5" => "",
"Optional6" => ""
);


$recharge_parameter = array_keys_replace($apis_value, array_values($request));


db_update("reports", [
"api_id"=>$apis_array['api_id'],
"api_name"=>$apis_array['api_name'],
"api_request"=>$apis_array['recharge_url'],
"recharge_method"=>$apis_array['recharge_method'],
"recharge_parameter"=>$apis_array['recharge_method'] == 'BODY' ? json_encode($recharge_parameter) : build_http_query($recharge_parameter)
], 
" order_id='".$order_id."' ");

// Api Request Handle
if($apis_array['recharge_method']=="GET"){
$recharge_parameter = '?'.build_http_query($recharge_parameter);
$url = $apis_array['recharge_url'].$recharge_parameter;
$http_response = HttpRequest::get($url);
}else if($apis_array['recharge_method']=="POST"){
$url = $apis_array['recharge_url'];
$recharge_parameter = build_http_query($recharge_parameter);
$http_response = HttpRequest::post($url,$recharge_parameter);
}else if($apis_array['recharge_method']=="BODY"){
parse_str(parse_url('?'.build_http_query($recharge_parameter),PHP_URL_QUERY),$recharge_parameter);  
$recharge_parameter = json_encode($recharge_parameter);
$url = $apis_array['recharge_url'];
$http_response = HttpRequest::post($url,$recharge_parameter,array('Content-Type:application/json'));
}


// Api Response Handle
if($apis_array['recharge_response_type']=="JSON"){
$json_response = $http_response;
$response = api_response_json($json_response,json_decode($apis_array['recharge_response'],true));
}else if($apis_array['recharge_response_type']=="XML"){
$xml = simplexml_load_string($http_response);
$json_response = json_encode($xml);
$response = api_response_json($json_response,json_decode($apis_array['recharge_response'],true));
}else if($apis_array['recharge_response_type']=="TEXT"){
$json_response = $http_response;
$response = api_response_text($json_response,json_decode($apis_array['recharge_response'],true),$apis_array['separate']);
}

//print_r($http_response);
// Final Response Handle
$result['recharge_url']  = $apis_array['recharge_url']; 
$result['recharge_method']  = $apis_array['recharge_method']; 
$result['recharge_parameter']  = $recharge_parameter;  
$result['recharge_response']  = $http_response;  
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name'];
$result['api_type']  = $apis_array['api_type']; 
$result['orderid']  = $OrderID;   
$result['client_orderid']  = $OrderID;  

if($response->Status=="Success"){
$result['status']  = 'Success'; 
$result['message']  = $response->Remark;   
$result['opid']  = $response->OperatorID; 
$result['api_orderid']  = $response->TxnID;  
}else if($response->Status=="Failed"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else if($response->Status=="Refund"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else{
$result['status']  = 'Pending'; 
$result['message']  = 'Transaction is Processing, Please Wait';  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;  
}     
     
}else{
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name']; 
$result['api_type']  = $apis_array['api_type'];
$result['orderid']  = $order_id;   
$result['client_orderid']  = $order_id;  
$result['status']  = 'Failed'; 
$result['message']  = "Wrong Api Selected";  
$result['recharge_response']  = $result['message'];  
$result['opid']  = '';
$result['api_orderid']  = '';
}
    
return $result;

}




function status_recharge_api($order_id,$api_order_id,$api_id){
$result = array();   
$apis_array = apis_deatils($api_id);
if(count($apis_array)){
  
$request = json_decode($apis_array['status_parameter'],true);


$Api_Key = $apis_array['api_key'];
$Username = $apis_array['api_username'];
$Password = $apis_array['api_password'];
$OrderID = $order_id;

$apis_value = array(
'Api_Key'   => $Api_Key,
'Username'  => $Username,
'Password'  => $Password,
'Mobile'    => "",
'Operator'  => "",
'Amount'    => "",
'OrderID'   => $OrderID,
"Optional1" => urlencode($api_order_id),
"Optional2" => "",
"Optional3" => "",
"Optional4" => "",
"Optional5" => "",
"Optional6" => ""
);


$recharge_parameter = array_keys_replace($apis_value, array_values($request));


// Api Request Handle
if($apis_array['status_method']=="GET"){
$recharge_parameter = '?'.build_http_query($recharge_parameter);
$url = $apis_array['status_url'].$recharge_parameter;
$http_response = HttpRequest::get($url);
}else if($apis_array['status_method']=="POST"){
$url = $apis_array['status_url'];
$recharge_parameter = build_http_query($recharge_parameter);
$http_response = HttpRequest::post($url,$recharge_parameter);
}else if($apis_array['status_method']=="BODY"){
parse_str(parse_url('?'.build_http_query($recharge_parameter),PHP_URL_QUERY),$recharge_parameter);  
$recharge_parameter = json_encode($recharge_parameter);
$url = $apis_array['status_url'];
$http_response = HttpRequest::post($url,$recharge_parameter,array('Content-Type:application/json'));
}


// Api Response Handle
if($apis_array['status_response_type']=="JSON"){
$json_response = $http_response;
$response = api_response_json($json_response,json_decode($apis_array['status_response'],true));
}else if($apis_array['status_response_type']=="XML"){
$xml = simplexml_load_string($http_response);
$json_response = json_encode($xml);
$response = api_response_json($json_response,json_decode($apis_array['status_response'],true));
}else if($apis_array['status_response_type']=="TEXT"){
$json_response = $http_response;
$response = api_response_text($json_response,json_decode($apis_array['status_response'],true));
}

//print_r($http_response);
// Final Response Handle
$result['status_url']  = $apis_array['status_url']; 
$result['status_method']  = $apis_array['status_method']; 
$result['status_parameter']  = $recharge_parameter;  
$result['status_response']  = $http_response;  
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name'];
$result['api_type']  = $apis_array['api_type']; 
$result['orderid']  = $OrderID;   
$result['client_orderid']  = $OrderID;  

if($response->Status=="Success"){
$result['status']  = 'Success'; 
$result['message']  = $response->Remark;   
$result['opid']  = $response->OperatorID; 
$result['api_orderid']  = $response->TxnID;  
}else if($response->Status=="Failed"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else if($response->Status=="Refund"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else{
$result['status']  = 'Pending'; 
$result['message']  = 'Transaction is Processing, Please Wait';  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;  
}     
     
}else{
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name']; 
$result['api_type']  = $apis_array['api_type'];
$result['orderid']  = $order_id;   
$result['client_orderid']  = $order_id;  
$result['status']  = 'Failed'; 
$result['message']  = "Wrong Api Selected";  
$result['opid']  = '';
$result['api_orderid']  = '';
}
    
return $result;

}





function dispute_recharge_api($order_id,$Optional1,$Optional2,$api_id){
$result = array();   
$apis_array = apis_deatils($api_id);
if(count($apis_array)){
  
$request = json_decode($apis_array['dispute_parameter'],true);


$Api_Key = $apis_array['api_key'];
$Username = $apis_array['api_username'];
$Password = $apis_array['api_password'];
$OrderID = $order_id;

$apis_value = array(
'Api_Key'   => $Api_Key,
'Username'  => $Username,
'Password'  => $Password,
'Mobile'    => "",
'Operator'  => "",
'Amount'    => "",
'OrderID'   => $OrderID,
"Optional1" => urlencode($Optional1),
"Optional2" => urlencode($Optional2),
"Optional3" => "",
"Optional4" => "",
"Optional5" => "",
"Optional6" => ""
);


$recharge_parameter = array_keys_replace($apis_value, array_values($request));


// Api Request Handle
if($apis_array['dispute_method']=="GET"){
$recharge_parameter = '?'.build_http_query($recharge_parameter);
$url = $apis_array['dispute_url'].$recharge_parameter;
$http_response = HttpRequest::get($url);
}else if($apis_array['dispute_method']=="POST"){
$url = $apis_array['dispute_url'];
$recharge_parameter = build_http_query($recharge_parameter);
$http_response = HttpRequest::post($url,$recharge_parameter);
}else if($apis_array['dispute_method']=="BODY"){
parse_str(parse_url('?'.build_http_query($recharge_parameter),PHP_URL_QUERY),$recharge_parameter);  
$recharge_parameter = json_encode($recharge_parameter);
$url = $apis_array['dispute_url'];
$http_response = HttpRequest::post($url,$recharge_parameter,array('Content-Type:application/json'));
}

// Api Response Handle
if($apis_array['dispute_response_type']=="JSON"){
$json_response = $http_response;
$response = api_response_json($json_response,json_decode($apis_array['dispute_response'],true));
}else if($apis_array['dispute_response_type']=="XML"){
$xml = simplexml_load_string($http_response);
$json_response = json_encode($xml);
$response = api_response_json($json_response,json_decode($apis_array['dispute_response'],true));
}else if($apis_array['dispute_response_type']=="TEXT"){
$json_response = $http_response;
$response = api_response_text($json_response,json_decode($apis_array['dispute_response'],true));
}

//print_r($http_response);
// Final Response Handle
$result['dispute_url']  = $apis_array['dispute_url']; 
$result['dispute_method']  = $apis_array['dispute_method']; 
$result['dispute_parameter']  = $recharge_parameter;  
$result['dispute_response']  = $http_response;  
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name'];
$result['api_type']  = $apis_array['api_type']; 
$result['orderid']  = $OrderID;   
$result['client_orderid']  = $OrderID;  

if($response->Status=="Success"){
$result['status']  = 'Success'; 
$result['message']  = $response->Remark;   
$result['opid']  = $response->OperatorID; 
$result['api_orderid']  = $response->TxnID;  
}else if($response->Status=="Failed"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else if($response->Status=="Refund"){
$result['status']  = 'Failed'; 
$result['message']  = $response->Remark;  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;
}else{
$result['status']  = 'Pending'; 
$result['message']  = 'Transaction is Processing, Please Wait';  
$result['opid']  = $response->OperatorID;
$result['api_orderid']  = $response->TxnID;  
}     
     
}else{
$result['api_id']  = $apis_array['api_id'];  
$result['api_name']  = $apis_array['api_name']; 
$result['api_type']  = $apis_array['api_type'];
$result['orderid']  = $order_id;   
$result['client_orderid']  = $order_id;  
$result['status']  = 'Failed'; 
$result['message']  = "Wrong Api Selected";  
$result['opid']  = '';
$result['api_orderid']  = '';
}
    
return $result;

}


function get_recharge_run1($accountnumber,$operator_id,$amount,$order_id,$operator_data){
$output = array();

// api_id_one
$response = send_recharge_api($accountnumber,$operator_id,$amount,$order_id,$operator_data['api_id_one']);
//print_r($response);
$output['results'] = $response;
if($response['status']=="Success"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else if($response['status']=="Failed" || $response['status']=="Refund"){

if(!empty($operator_data['api_id_two'])){
// api_id_two    
$response = send_recharge_api($accountnumber,$operator_id,$amount,$order_id,$operator_data['api_id_two']);  
$output['results'] = $response;  
if($response['status']=="Success"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else if($response['status']=="Failed" || $response['status']=="Refund"){

if(!empty($operator_data['api_id_three'])){
// api_id_three    
$response = send_recharge_api($accountnumber,$operator_id,$amount,$order_id,$operator_data['api_id_three']); 
$output['results'] = $response;   
if($response['status']=="Success"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else if($response['status']=="Failed" || $response['status']=="Refund"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}


}else{
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];    
}


}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}    


}else{
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];    
}


}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}

return $output;    
}





function get_status_run1($order_id,$api_order_id='',$api_id){
$output = array();

$response = status_recharge_api($order_id,$api_order_id,$api_id);
$output['results'] = $response;   
if($response['status']=="Success"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else if($response['status']=="Failed" || $response['status']=="Refund"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['api_orderid'];
$output['ref_id'] = $response['opid'];
}


return $output;    
}


function get_recharge_dispute1($order_id,$api_order_id,$reason,$api_id){
$output = array();

$response = dispute_recharge_api($order_id,$api_order_id,$reason,$api_id);
if($response['status']=="Success"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['opid'];
}else if($response['status']=="Failed" || $response['status']=="Refund"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['opid'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['opid'];
}

return $output;
}

// Static API
function get_recharge_run($accountnumber,$api_operator_id,$amount,$order_id){
$recharge_token = apis("recharge_token");
$recharge_apikey = apis("recharge_apikey");
$response = http_get("https://www.flowzy.app/webservices/api/recharge?username={$recharge_token}&api_token={$recharge_apikey}&number={$accountnumber}&amount={$amount}&operator={$api_operator_id}&ref_id={$order_id}");
$response = json_decode($response,true);
$output = array();
if($response['status']=="Success" || $response['status']=="Accepted"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['txn_id'];
$output['ref_id'] = $response['opt_id'];
}else if($response['status']=="Failure" || $response['status']=="Refunded" || $response['status']=="Error"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['txn_id'];
$output['ref_id'] = $response['opt_id'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['txn_id'];
$output['ref_id'] = $response['opt_id'];
}

return $output;
}

function recharge_status($response){
$output = array();
if($response['status']=="Success" || $response['status']=="Accepted"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['txn_id'] = $response['refId'];
$output['ref_id'] = $response['operatorId'];
}else if($response['status']=="Failure" || $response['status']=="Refunded"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['txn_id'] = $response['refId'];
$output['ref_id'] = $response['operatorId'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['txn_id'] = $response['refId'];
$output['ref_id'] = $response['operatorId'];
}
return $output;
}


function get_recharge_dispute($txn_id,$reason){
$recharge_token = apis("recharge_token");
$recharge_apikey = apis("recharge_apikey");
$reason = urlencode($reason);
$response = http_get("https://www.flowzy.app/webservices/api/complain?username={$recharge_token}&api_token={$recharge_apikey}&txn_id={$txn_id}&reason={$reason}");
$response = json_decode($response,true);
$output = array();
if($response['status']=="Success" || $response['status']=="Accepted"){
$output['status'] = "Success";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['complain_id'];
}else if($response['status']=="Failure" || $response['status']=="Refunded" || $response['status']=="Error"){
$output['status'] = "Failed";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['complain_id'];
}else{
$output['status'] = "Pending";
$output['message'] = $response['message'];
$output['dispute_id'] = $response['complain_id'];
}

return $output;
}



function get_dth_customer_info($accountnumber,$operator_id){

if(!empty($accountnumber) && !empty($operator_id)){
$operator_data = db_fetch_array("operators"," operator_id='".$operator_id."' AND status='1' ");
if($operator_data['operator_id']>0 && !empty($operator_data['plan_operator_id'])){
$planapi_username = apis("planapi_username");
$planapi_password = apis("planapi_password");  
$plan_operator_id =  $operator_data['plan_operator_id'];
$url = "http://planapi.in/api/Mobile/DTHINFOCheck?apimember_id=$planapi_username&api_password=$planapi_password&Opcode=$plan_operator_id&mobile_no=$accountnumber";
$response = strtolower(http_get($url));   
$response = json_decode($response,true);
if(!empty($response['data'])){
$data = $response['data'];
$address = strtoupper(implode(' ',[$data['address'],$data['pin code']]));
$data['name'] = strtoupper($data['name']);
$data['plan'] = strtoupper($data['plan']);
$html = '<div class="card">';
$html .= '<div class="card-body">';


$html .= '<table class="table table-sm">
<thead>
<tr><th>Operator Name</th><th>'.$operator_data['operator_name'].'</th></tr>
<tr><th>DTH Customer No</th><th>'.$data['vc'].'</th></tr>
<tr><th>Customer Name</th><th>'.$data['name'].'</th></tr>
<tr><th>Mobile Number</th><th>'.$data['rmn'].'</th></tr>
<tr><th>Balance</th><th>'.$data['balance'].'</th></tr>
<tr><th>Monthly</th><th>'.$data['monthly'].'</th></tr>
<tr><th>Plan</th><th>'.$data['plan'].'</th></tr>
<tr><th class="border-0">Address</th><th class="border-0">'.$address.'</th></tr>
</thead>
</table>';


$html .= '</div></div>';
$html .= '</div>';

$output['status'] = true;
$output['message'] = "Offer Fetch Successfully"; 
$output['html'] = $html; 
}else{
$output['status'] = false;
$output['message'] = $response['message'];       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Valid";       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Found";       
}

return $output;
}


function get_mobile_plan($accountnumber,$operator_id){
if(!empty($accountnumber) && !empty($operator_id)){
$operator_data = db_fetch_array("operators"," operator_id='".$operator_id."' AND status='1' ");
if($operator_data['operator_id']>0 && !empty($operator_data['plan_operator_id'])){
$planapi_username = apis("planapi_username");
$planapi_password = apis("planapi_password");  
$plan_operator_id =  $operator_data['plan_operator_id'];
$url = "http://planapi.in/api/Mobile/Operatorplan?apimember_id=$planapi_username&api_password=$planapi_password&cricle=31&operatorcode=$plan_operator_id";
$response = strtolower(http_get($url));   
$response = json_decode($response,true);
if(count($response['rdata'])>0 && !empty($response['rdata'])){

$html = '<div class="card">';


$html .= '<div class="card-header"><ul class="nav nav-tabs card-header-tabs">';
$i=0;
foreach($response['rdata'] as $key => $value){
$status = $i==0?'active':'';
$html .= '<li class="nav-item"><a class="nav-link '.$status.' " data-toggle="tab" href="#'.$key.'">'.strtoupper($key).'</a></li>';
$i++;}

$html .= '</ul></div>';

$html .= '<div class="card-body"><div class="tab-content">';
$i=0;
foreach($response['rdata'] as $key => $value){
$status = $i==0?'active show':'';
$html .= '<div class="tab-pane fade '.$status.' " id="'.$key.'">';

$html .= '<table class="table table-sm">
<thead>
<tr>
<th>Validity</th>
<th>Description</th>
<th>Price</th>
</tr>
</thead>
</table>';

$html .= '<div class="table-responsive scroll" style="max-height:245px"><table class="table table-bordered table-sm"><thead>';
foreach($value as $k => $v){
$v['validity'] = ucwords($v['validity']);  
$v['desc'] = ucwords($v['desc']);       
$html .= '<tr>
<td>'.$v['validity'].'</td>
<td>'.$v['desc'].'</td>
<td><button class="btn btn-outline-primary btn-sm" onclick="pickAmt(\''.$v['rs'].'\',\'amount\',\''.$v['desc'].'\',\'description\')">₹'.$v['rs'].'</button></td>
</tr>';
}
$html .= '</thead></table></div>';

$html .= '</div>';
$i++;}

$html .= '</div></div>';

$html .= '</div>';

$output['status'] = true;
$output['message'] = "Plan Fetch Successfully"; 
$output['html'] = $html; 
}else{
$output['status'] = false;
$output['message'] = $response['message'];       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Valid";       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Found";       
}

return $output;
}


function get_mobile_roffer($accountnumber,$operator_id){

if(!empty($accountnumber) && !empty($operator_id)){
$operator_data = db_fetch_array("operators"," operator_id='".$operator_id."' AND status='1' ");
if($operator_data['operator_id']>0 && !empty($operator_data['plan_operator_id'])){
$planapi_username = apis("planapi_username");
$planapi_password = apis("planapi_password");  
$plan_operator_id =  $operator_data['plan_operator_id'];
$url = "http://planapi.in/api/Mobile/RofferCheck?apimember_id=$planapi_username&api_password=$planapi_password&operator_code=$plan_operator_id&mobile_no=$accountnumber";
$response = strtolower(http_get($url));   
$response = json_decode($response,true);
if(!empty($response['rdata'])){
$html = '<div class="card">';
$html .= '<div class="card-body">';


$html .= '<table class="table table-sm">
<thead>
<tr>
<th>Description</th>
<th>Price</th>
</tr>
</thead>
</table>';

$html .= '<div class="table-responsive scroll" style="max-height:245px"><table class="table table-bordered table-sm"><thead>';
foreach($response['rdata'] as $k => $v){
$v['ofrtext'] = strtoupper($v['ofrtext']);  
$v['logdesc'] = strtoupper($v['logdesc']);       
$html .= '<tr>
<td>'.$v['logdesc'].'</td>
<td><button class="btn btn-outline-primary btn-sm" onclick="pickAmt(\''.$v['price'].'\',\'amount\',\''.$v['logdesc'].'\',\'description\')">₹'.$v['price'].'</button></td>
</tr>';
}
$html .= '</thead></table></div>';



$html .= '</div></div>';
$html .= '</div>';

$output['status'] = true;
$output['message'] = "Offer Fetch Successfully"; 
$output['html'] = $html; 
}else{
$output['status'] = false;
$output['message'] = $response['message'];       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Valid";       
}

}else{
$output['status'] = false;
$output['message'] = "Operator Not Found";       
}

return $output;
}




function get_mobile_operator($accountnumber){

if(is_numeric($accountnumber) && strlen($accountnumber)==10){

//$planapi_username = apis("planapi_username");
//$planapi_password = apis("planapi_password");  
$plan_operator_id =  $operator_data['plan_operator_id'];
$url = "https://planapi.in/api/Mobile/OperatorFetchNew?ApiUserID=5885&ApiPassword=Sankar@123&Mobileno='.$accountnumber";
$response = strtolower(file_get_contents($url));
$response = json_decode($response,true);
if($response['status']>0){
$plan_operator_id = $response['opcode'];
$operator_data = db_fetch_array("operators"," plan_operator_id='".$plan_operator_id."' AND status='1' ");
if($operator_data['operator_id']>0){
$output['status'] = true;
$output['message'] = "Operator Fetch Successfully"; 
$output['operator_id'] = $operator_data['operator_id']; 
}else{
$output['status'] = false;
$output['message'] = "Operator Not Found";       
}

}else{
$output['status'] = false;
$output['message'] = $response['message'];       
}

}else{
$output['status'] = false;
$output['message'] = "Mobile Number Not Valid";       
}

return $output;
}

function pancard_api_balance(){
$post_data = json_encode([
  "token" => apis("panapi_token"),
]); 
$resJson = http_post("https://easysmart.in/app/api/user/balanceCheck",$post_data,["Content-Type: application/json"]);
$response = json_decode($resJson,true);
if($response['status']=="Success"){
$output = array("status"=>true,"message"=>"Fetch Successfully","balance"=>$response['user_balance']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}



function recharge_api_balance(){
$recharge_token = apis("recharge_token");
$recharge_apikey = apis("recharge_apikey");
$response = http_get("https://www.flowzy.app/webservices/api/balance?username={$recharge_token}&api_token={$recharge_apikey}");
$response = json_decode($response,true);
if($response['status']=="Success"){
$output = array("status"=>true,"message"=>"Fetch Successfully","balance"=>$response['mainBalance']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}


function nsdl_pan_track($ack_no){
$post_data = json_encode([
  "api_key" => apis("panapi_apikey"),
  "ack_no"=>$ack_no,
]); 
$resJson = http_post("https://easysmart.in/app/admin/ApiNsdlController/panStatus",$post_data,["Content-Type: application/json"]);
$response = json_decode($resJson,true);
if($response['status']=="Success"){
$output = array("status"=>true,"message"=>$response['message'],"pan"=>$response['pan']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}


function panfind_run($request){
$getData = http_build_query([
    'api_key' => apis("panfind_apikey"),
    'aadhaar_no' => $request['aadhaar'],
    'dob' => $request['dob'],
    'name' => $request['name'],
    'application_no' => $request['order_id'],
]);

$resJson = http_get("https://webtechly.co.in/api/aadhaar_to_pan.php?$getData");
$response = json_decode($resJson,true);
if($response['status']==true && in_array($response['response_code'],[1,41])){
$output = array("status"=>true,"message"=>$response['message'],"pan_no"=>$response['pan_no']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}
return $output;
}


function panfind_status($request){
$getData = http_build_query([
    'api_key' => apis("panfind_apikey"),
    'application_no' => $request['order_id'],
]);

$resJson = http_get("https://webtechly.co.in/api/instant_status.php?$getData");
$response = json_decode($resJson,true);
if($response['status']==true){
$output = array("status"=>"Success","message"=>$response['message'],"pan_no"=>$response['pan_no']);
}else if($response['response_code']==905){
$output = array("status"=>"Failed","message"=>$response['message']); 
}else{
$output = array("status"=>"Pending","message"=>$response['message']); 
}
return $output;
}


function upigateway_status($client_txn_id,$txn_date){
$post_data = json_encode([
    "user_token"=>'e8d2a2f1ac98d41d3b7422fd11ab98fa',//paymentapi("upigateway_token"),
    "order_id"=>$client_txn_id,
    "txn_date"=>$txn_date,
]);
$response = http_post("https://epanservices.online/api/check-order-status",$post_data,["Content-Type:application/json"]);
return json_decode($response,true);
}


function smartupi_status($order_id){
$post_data = json_encode([
    "token"=>paymentapi("smartupi_token"),
    "order_id"=>$order_id
]);

$response = http_post("https://qrapipro.aiautomation.co.in/order/status",$post_data,["Content-Type:application/json"]);
return json_decode($response,true);
}


function nsdl_decode($encData){
return openssl_decrypt(base64_decode($encData), "AES-128-CBC", apis("panapi_apikey"), 0,apis("panapi_secret"));
}




function revamp_onbording($user_data){

$vleid = get_vle_id($user_data['pan'],$user_data['mobile']);
$address = substr($user_data['address'],0,25);
$post_data = json_encode([
   "api_key" => apis("botapi_apikey"), 
   "bot_id" => apis("botapi_botid"), 
   "vleid" => $vleid, 
   "vlename" => $user_data['company'],
   "contactperson" => $user_data['name'], 
   "address1" => $address, 
   "address2" => $address, 
   "address3" => "", 
   "address4" => "", 
   "location" => $address, 
   "state" => $user_data['state'], 
   "district" => "OTHER", 
   "pincode" => $user_data['pin'],
   "email" => $user_data['email'],
   "mobile" => $user_data['mobile'], 
   "pan" => $user_data['pan'],
]); 

$resJson = http_post("https://phpstack-735129-3327201.cloudwaysapps.com/Api/PSACreate",$post_data,["Content-Type: application/json"],0,true);
$response = json_decode($resJson,true);
if($response['status']=="SUCCESS"){
$revamp_code = filter_var($response['message'], FILTER_SANITIZE_NUMBER_INT);
if(db_update("members", ["revamp_id"=>$vleid,"revamp_code"=>$revamp_code,"revamp_active"=>"YES","status"=>"Active"], " user_id='".$user_data['user_id']."' ")){  
$output = array("status"=>true,"message"=>"PSA Onbording Successfully");
}
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}

return $output;

}


function revamp_password($user_data){
$post_data = json_encode([
   "api_key" => apis("botapi_apikey"), 
   "bot_id" => apis("botapi_botid"), 
   "vle_id" => $user_data['revamp_id'],
]); 

$resJson = http_post("https://phpstack-735129-3327201.cloudwaysapps.com/Api/PasswordReset",$post_data,["Content-Type: application/json"],0,true);
$response = json_decode($resJson,true);
if($response['status']=="SUCCESS"){
$output = array("status"=>true,"message"=>"PSA Onbording Successfully");
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}

return $output;

}

function revamp_token($vle_id,$utr_no,$quantity){
$post_data = json_encode([
   "api_key" => apis("botapi_apikey"), 
   "bot_id" => apis("botapi_botid"), 
   "vle_id" => $vle_id,
   "utr_no" => $utr_no,
   "amount" => 107 * $quantity,
]); 

$resJson = http_post("https://phpstack-735129-3327201.cloudwaysapps.com/Api/WalletTransfer",$post_data,["Content-Type: application/json"],0,true);
$response = json_decode($resJson,true);
if($response['status']=="SUCCESS"){
$output = array("status"=>true,"message"=>"Transfer Successfully","results"=>$response['results']);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}

return $output;

}

function get_full_name($results){
 return strtoupper(trim(implode(" ",array_filter([$results['first_name'],$results['mid_name'],$results['last_name']]))));   
} 



function pan_verify($pan_number,$aadhaar_number){
$post_data = json_encode([
   "token" => apis("swiftapi_token"), 
   "aadhaar_number" => $aadhaar_number, 
   "pan_number" => $pan_number,
]); 

$resJson = http_post("https://swiftapi.aiautomation.co.in/api/pan_aadhaar_status",$post_data,["Content-Type: application/json"],0,true);
$response = json_decode($resJson,true);
if($response['status']==true){
$output = array("status"=>true,"message"=>"Linked Successfully","results"=>$response);
}else{
$output = array("status"=>false,"message"=>"Your PAN <$pan_number> is Linked To Some Other Aadhaar"); 
}

return $output;

}




function aadhaar_captcha($aadhaar_number){
$post_data = json_encode([
   "token" => apis("swiftapi_token"), 
   "aadhaar_number" => $aadhaar_number,
]); 

$header = array(
    'Content-Type: application/json' 
);

$resJson = http_post("https://swiftapi.aiautomation.co.in/api/aadhaar_okyc_captcha",$post_data,$header,0,true);
$response = json_decode($resJson,true);
if($response['status']==true){
$output = array("status"=>true,"message"=>"Captcha Generated Successfully","results"=>["captcha_image"=>$response['captcha_image'],"authorization"=>$response['authorization']]);
}else{
$output = array("status"=>false,"message"=>$response['message']); 
}

return $output;

}

function aadhaar_verify($request){
$post_data = json_encode([
   "token" => apis("swiftapi_token"), 
   "aadhaar_number" => $request['aadhaar_number'], 
   "captcha_code" => $request['captcha_code'],
]); 

$header = array(
    'Authorization: '.$request['authorization'],
    'Content-Type: application/json' 
);

$resJson = http_post("https://swiftapi.aiautomation.co.in/api/aadhaar_okyc_otp",$post_data,$header,0,true);
$response = json_decode($resJson,true);
if($response['status']==true){
$output = array("status"=>true,"message"=>"OTP Has Been Sent Successfully","results"=>$response);
}else{
$output = array("status"=>false,"message"=>$response['message']);
}

return $output;

}



function aadhaar_otp_verify($request){
$post_data = array(
   "token" => apis("swiftapi_token"), 
   "aadhaar_number" => $request['aadhaar_number'], 
   "otp" => $request['otp'],
); 

$header = array(
    'Authorization: '.$request['authorization'],
    'Content-Type: application/json' 
);

$resJson = http_post("https://swiftapi.aiautomation.co.in/api/aadhaar_okyc_verify",json_encode($post_data),$header,0,true);
$response = json_decode($resJson,true);
if($response['status']==true){
$key =  substr(md5(base64_encode($post_data['token'].":".$post_data['aadhaar_number'])),16);	
$results = json_decode(aes_decrypt($response['results']['encryption'],$key),true);
unset($response['results']['encryption']);	
$results = array_merge($response['results'],$results);
$output = array("status"=>true,"message"=>"Verified Successfully","results"=>$results);
}else{
$output = array("status"=>false,"message"=>$response['message']);  
}

return $output;

}